import stanford.karel.*;


public class BanishWinter extends SuperKarel {

	public void run() {
		for(int i = 0; i < 4; i++) {
			moveToTree();
			bloomTree();
		}
	}

	private void bloomTree() {
		goUpTree();
		addLeaves();
		goDownTree();
		
	}

	/**
	 * Method: Add Leaves
	 * ------------------
	 * This method add leaves (beepers) to the top of a tree.
	 * Assumes that at the start of the method karel is facing
	 * east at the bottom left corner of the leaves. After the 
	 * method karel is in the same position, but there are some
	 * pretty leaves.
	 */
	private void addLeaves() {
		for(int i = 0; i < 4; i++) {
			putBeeper();
			move();
			turnLeft();
		}
	}
	
	private void goDownTree() {
		move();
		turnRight();
		while(frontIsClear()) {
			move();
		}
		turnLeft();
	}

	private void goUpTree() {
		turnLeft();
		while(rightIsBlocked()) {
			move();
		}
		turnRight();
	}

	private void moveToTree() {
		while(frontIsClear()) {
			move();
		}
	}

}
